Log::Metadata::Value - Crystal 1.20.3

# struct Log::Metadata::Value

- Log::Metadata::Value
- Struct
- Value
- Object

##
Defined in:

log/json.cr
log/metadata.cr:7
log/metadata.cr:204

##
Constructors

- .new(raw : Type)

  Creates a `Log::Metadata::Value` that wraps the given `Type`.

- .new(hash : NamedTuple | Hash)

  Creates `Log::Metadata` from the given values.

##
Instance Method Summary

- #==(other : self)

  Returns `true` if both `self` and other's raw object are equal.

- #==(other)

  Returns `true` if the raw object is equal to other.

- #[](index_or_key) : self

  Assumes the underlying value is an `Array` or `Hash` and returns the element at the given index_or_key.

- #[]?(index_or_key) : self | Nil

  Assumes the underlying value is an `Array` or `Hash` and returns the element at the given index_or_key, or `nil` if out of bounds or the key is missing.

- #as_a : Array(self)

  Checks that the underlying value is `Array(self)`, and returns its value.

- #as_a? : Array(self) | Nil

  Checks that the underlying value is `Array(self)`, and returns its value.

- #as_bool : Bool

  Checks that the underlying value is `Bool`, and returns its value.

- #as_bool? : Bool | Nil

  Checks that the underlying value is `Bool`, and returns its value.

- #as_f : Float32

  Checks that the underlying value is `Float32`, and returns its value.

- #as_f64 : Float64

  Checks that the underlying value is `Float64`, and returns its value.

- #as_f64? : Float64 | Nil

  Checks that the underlying value is `Float64`, and returns its value.

- #as_f? : Float32 | Nil

  Checks that the underlying value is `Float32`, and returns its value.

- #as_h : Hash(String, self)

  Checks that the underlying value is `Hash(String, self)`, and returns its value.

- #as_h? : Hash(String, self) | Nil

  Checks that the underlying value is `Hash(String, self)`, and returns its value.

- #as_i : Int32

  Checks that the underlying value is `Int32`, and returns its value.

- #as_i64 : Int64

  Checks that the underlying value is `Int64`, and returns its value.

- #as_i64? : Int64 | Nil

  Checks that the underlying value is `Int64`, and returns its value.

- #as_i? : Int32 | Nil

  Checks that the underlying value is `Int32`, and returns its value.

- #as_nil : Nil

  Checks that the underlying value is `Nil`, and returns its value.

- #as_s : String

  Checks that the underlying value is `String`, and returns its value.

- #as_s? : String | Nil

  Checks that the underlying value is `String`, and returns its value.

- #as_time : Time

  Checks that the underlying value is `Time`, and returns its value.

- #as_time? : Time | Nil

  Checks that the underlying value is `Time`, and returns its value.

- #as_u : UInt32

  Checks that the underlying value is `UInt32`, and returns its value.

- #as_u64 : UInt64

  Checks that the underlying value is `UInt64`, and returns its value.

- #as_u64? : UInt64 | Nil

  Checks that the underlying value is `UInt64`, and returns its value.

- #as_u? : UInt32 | Nil

  Checks that the underlying value is `UInt32`, and returns its value.

- #clone

  Returns a new `Log::Metadata::Value` instance with the `#raw` value `#clone`ed.

- #dig(index_or_key, *subkeys) : self

  Traverses the depth of a structure and returns the value, otherwise raises.

- #dig?(index_or_key, *subkeys) : self | Nil

  Traverses the depth of a structure and returns the value.

- #dup

  Returns a new `Log::Metadata::Value` instance with the `#raw` value `#dup`ed.

- #hash(hasher)

  See `Object#hash(hasher)`

- #inspect(io : IO) : Nil

  Appends this struct's name and instance variables names and values to the given IO.

- #raw : Type

  Returns the raw underlying value, a `Type`.

- #size : Int

  Assumes the underlying value is an `Array` or `Hash` and returns its size.

- #to_json(builder : JSON::Builder) : Nil

  Returns `Log::Metadata::Value` as JSON value.

- #to_s(io : IO) : Nil

  Same as `#inspect(io)`.

### Instance methods inherited from struct `Struct`

==(other : YAML::Any)
==(other) : Bool ==, hash(hasher) hash, inspect(io : IO) : Nil inspect, pretty_print(pp) : Nil pretty_print, to_s(io : IO) : Nil to_s

### Class methods inherited from struct `Struct`

pre_initialize(address : Pointer) : Nil pre_initialize

### Instance methods inherited from struct `Value`

==(other : Log::Metadata::Value)
==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup

### Instance methods inherited from class `Object`

! : Bool !, !=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, as(type : Class) as, as?(type : Class) as?, class class, dup dup, hash(hasher)
hash hash, in?(collection : Object) : Bool
in?(*values : Object) : Bool in?, inspect(io : IO) : Nil
inspect : String inspect, is_a?(type : Class) : Bool is_a?, itself itself, nil? : Bool nil?, not_nil!(message)
not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, responds_to?(name : Symbol) : Bool responds_to?, tap(&) tap, to_json(io : IO) : Nil
to_json : String to_json, to_pretty_json(indent : String = " ") : String
to_pretty_json(io : IO, indent : String = " ") : Nil to_pretty_json, to_s(io : IO) : Nil
to_s : String to_s, to_yaml(io : IO) : Nil
to_yaml : String to_yaml, try(&) try, unsafe_as(type : T.class) forall T unsafe_as

### Class methods inherited from class `Object`

from_json(string_or_io : String | IO, root : String)
from_json(string_or_io : String | IO) from_json, from_yaml(string_or_io : String | IO) from_yaml

### Macros inherited from class `Object`

class_getter(*names, &block) class_getter, class_getter!(*names) class_getter!, class_getter?(*names, &block) class_getter?, class_property(*names, &block) class_property, class_property!(*names) class_property!, class_property?(*names, &block) class_property?, class_setter(*names) class_setter, def_clone def_clone, def_equals(*fields) def_equals, def_equals_and_hash(*fields) def_equals_and_hash, def_hash(*fields) def_hash, delegate(*methods, to object) delegate, forward_missing_to(delegate) forward_missing_to, getter(*names, &block) getter, getter!(*names) getter!, getter?(*names, &block) getter?, property(*names, &block) property, property!(*names) property!, property?(*names, &block) property?, setter(*names) setter

##
Constructor Detail

def self.new(raw : Type) #

Creates a `Log::Metadata::Value` that wraps the given `Type`.

def self.new(hash : NamedTuple | Hash) #

Creates `Log::Metadata` from the given values. All keys are converted to `String`

##
Instance Method Detail

def ==(other : self) #

Returns `true` if both `self` and other's raw object are equal.

def ==(other) #

Returns `true` if the raw object is equal to other.

def [](index_or_key) : self #

Assumes the underlying value is an `Array` or `Hash` and returns the element at the given index_or_key.

Raises if the underlying value is not an `Array` nor a `Hash`.

def []?(index_or_key) : self | Nil #

Assumes the underlying value is an `Array` or `Hash` and returns the element at the given index_or_key, or `nil` if out of bounds or the key is missing.

Raises if the underlying value is not an `Array` nor a `Hash`.

def as_a : Array(self) #

Checks that the underlying value is `Array(self)`, and returns its value. Raises otherwise.

def as_a? : Array(self) | Nil #

Checks that the underlying value is `Array(self)`, and returns its value. Returns `nil` otherwise.

def as_bool : Bool #

Checks that the underlying value is `Bool`, and returns its value. Raises otherwise.

def as_bool? : Bool | Nil #

Checks that the underlying value is `Bool`, and returns its value. Returns `nil` otherwise.

def as_f : Float32 #

Checks that the underlying value is `Float32`, and returns its value. Raises otherwise.

def as_f64 : Float64 #

Checks that the underlying value is `Float64`, and returns its value. Raises otherwise.

def as_f64? : Float64 | Nil #

Checks that the underlying value is `Float64`, and returns its value. Returns `nil` otherwise.

def as_f? : Float32 | Nil #

Checks that the underlying value is `Float32`, and returns its value. Returns `nil` otherwise.

def as_h : Hash(String, self) #

Checks that the underlying value is `Hash(String, self)`, and returns its value. Raises otherwise.

def as_h? : Hash(String, self) | Nil #

Checks that the underlying value is `Hash(String, self)`, and returns its value. Returns `nil` otherwise.

def as_i : Int32 #

Checks that the underlying value is `Int32`, and returns its value. Raises otherwise.

def as_i64 : Int64 #

Checks that the underlying value is `Int64`, and returns its value. Raises otherwise.

def as_i64? : Int64 | Nil #

Checks that the underlying value is `Int64`, and returns its value. Returns `nil` otherwise.

def as_i? : Int32 | Nil #

Checks that the underlying value is `Int32`, and returns its value. Returns `nil` otherwise.

def as_nil : Nil #

Checks that the underlying value is `Nil`, and returns its value. Raises otherwise.

def as_s : String #

Checks that the underlying value is `String`, and returns its value. Raises otherwise.

def as_s? : String | Nil #

Checks that the underlying value is `String`, and returns its value. Returns `nil` otherwise.

def as_time : Time #

Checks that the underlying value is `Time`, and returns its value. Raises otherwise.

def as_time? : Time | Nil #

Checks that the underlying value is `Time`, and returns its value. Returns `nil` otherwise.

def as_u : UInt32 #

Checks that the underlying value is `UInt32`, and returns its value. Raises otherwise.

def as_u64 : UInt64 #

Checks that the underlying value is `UInt64`, and returns its value. Raises otherwise.

def as_u64? : UInt64 | Nil #

Checks that the underlying value is `UInt64`, and returns its value. Returns `nil` otherwise.

def as_u? : UInt32 | Nil #

Checks that the underlying value is `UInt32`, and returns its value. Returns `nil` otherwise.

def clone #

Returns a new `Log::Metadata::Value` instance with the `#raw` value `#clone`ed.

def dig(index_or_key, *subkeys) : self #

Traverses the depth of a structure and returns the value, otherwise raises.

def dig?(index_or_key, *subkeys) : self | Nil #

Traverses the depth of a structure and returns the value. Returns `nil` if not found.

def dup #

Returns a new `Log::Metadata::Value` instance with the `#raw` value `#dup`ed.

def hash(hasher) #

See `Object#hash(hasher)`

def inspect(io : IO) : Nil #
Description copied from struct Struct

Appends this struct's name and instance variables names and values to the given IO.

    struct Point
      def initialize(@x : Int32, @y : Int32)
      end
    end

    p1 = Point.new 1, 2
    p1.to_s    # "Point(@x=1, @y=2)"
    p1.inspect # "Point(@x=1, @y=2)"

def raw : Type #

Returns the raw underlying value, a `Type`.

def size : Int #

Assumes the underlying value is an `Array` or `Hash` and returns its size.

Raises if the underlying value is not an `Array` or `Hash`.

def to_json(builder : JSON::Builder) : Nil #

Returns `Log::Metadata::Value` as JSON value.

NOTE `require "log/json"` is required to opt-in to this feature.

def to_s(io : IO) : Nil #
Description copied from struct Struct

Same as `#inspect(io)`.